/**************************************************************\
* Copyright (C) 1997 - 2001 Vasile CALMATUI (vasile@wook.com)  *
*                                                              *
* This software is public domain. Permission is granted to     *
* use, copy and modify this software to anyone.                *
****************************************************************
* Please don't contact me for information, bugs, comments, job *
* offers. If you like this software, please send a postcard to *
* the following address:                                       *
* Vasile CALMATUI                                              *
* 35 str. Burebista                                            *
* 3600 Ungheni                                                 *
* MOLDOVA                                                      *
****************************************************************
* The author is not liable for damages resulting from  the use *
* of this software or its derivates.                           *
\**************************************************************/

import java.io.*;
import java.net.*;
import java.util.*;

public class VasFireWallMailReader {
  DataOutputStream out;
  DataInputStream in;
  int nbMails;//the number of mails received
  String iniFile=new String("mails.ini");
  //the file where we store the number of read mail
  String nmbFile=new String("mails.nmb");
  //the lines in which we are interested in the ini file
  String[] keywords={"user", "pass", "mailhost", "gateway", "outputfile", "wait"};
  //the value of these parameters
  String[] keyValue={"user", "pass", "mailhost", "gateway", "mails.txt", "yes"};
  boolean wait=true;
  //to obtain a "beauty" representation of the line separator
  String ls;

  public String toString() {
    return (new String("VasFireWallMailReader v2.3 September 5th, 1999, (C) 1997, 1998, 1999, 2000, 2001 Vasile Calmatui"));
  }//end toString

  public static void main(String[] args) {
    new VasFireWallMailReader();
  }//end main

  //constructor
  public VasFireWallMailReader() {
    ls=new String(System.getProperty("line.separator"));
    try {
      readIniFile();
      int already=readNmbFile();

      //specify wait parameter
      if(keyValue[5].equals("no")) wait=false;
      Socket sock=null;
      String line=null;
      //if there's no gateway, ie we have not "no" in the gateway field
      if(!keyValue[3].equals("no")) {
        try {
          //here your "telnet gateway"
          sock=new Socket(keyValue[3], 23);
          out=new DataOutputStream(sock.getOutputStream());
          in=new DataInputStream(sock.getInputStream());

          //firewall telnet proxy (Version 3.2) ready:
          line=in.readLine();
          System.out.println(line);
          out.writeBytes("telnet "+keyValue[2]+" 110\n");

          //tn-gw->telnet mail.club-internet.fr 110
          line=in.readLine();
          System.out.println(line);

          //Trying 194.158.97.88 port 110...
          line=in.readLine();
          System.out.println(line);

          //Connected to mail.club-internet.fr.
          line=in.readLine();
          System.out.println(line);
        }//try
        catch(IOException exc_gate) {System.out.println("Gateway connection problem: "+keyValue[3]); System.exit(-1);}
      }//if
      //without a gateway
      else {
        try {
          sock=new Socket(keyValue[2], 110);
          out=new DataOutputStream(sock.getOutputStream());
          in=new DataInputStream(sock.getInputStream());
        }//try
        catch(IOException exc_gate) {System.out.println("Mailhost connection problem: "+keyValue[2]); System.exit(-1);}
      }

      //+OK QPOP (version 2.2) at mailhost.grolier.fr starting.
      line=in.readLine();
      System.out.println(line);
      out.writeBytes("user "+keyValue[0]+"\r\n");
      System.out.println("user "+keyValue[0]);

      //+OK Password required for vasile.
      line=in.readLine();
      System.out.println(line);
      out.writeBytes("pass "+keyValue[1]+"\r\n");
      System.out.println("pass ********");

      //+OK vasile has 1 message (55210 octets).
      line=in.readLine();
      System.out.println(line);
      //if we got a bad login/password message
      if(line.charAt(0)!='+') {System.out.println("Login/Password problem"); System.exit(-1);}

      //we ask how much mails are left on the server
      out.writeBytes("stat\r\n");
      line=in.readLine();

      if(line.charAt(0)=='+') {
        //everything ok
        System.out.println("Connection OK");
        //reading how much messages are left on the server
        //+OK 1 1266
        nbMails=Integer.parseInt(line.substring(4, line.indexOf(' ', 5)));
        System.out.println("You have "+nbMails+" mails weighting "+line.substring(line.indexOf(' ', 5)+1)+" bytes");
      }
      //if there's one error, if '-'
      else {System.out.println("Connection problem"); System.out.println(line); System.exit(1);}

      if(wait) {
        out.writeBytes("list\r\n");

        //+OK 1 messages (1266 octets)
        line=in.readLine();

        //to read the size of mails
        for(int i=0; i<nbMails; i++) {
          //1 1266
          line=in.readLine();
          if(line.equals(".")) {System.exit(2);}
          int mail_length=Integer.parseInt(line.substring(line.indexOf(' ')+1));
          System.out.println("Mail "+(i+1)+" size "+mail_length);
        }
        //.
        line=in.readLine();
      }

      System.out.println("Already read: "+already);
      if(wait) {
        System.out.println("Enter - default\n0 - all\nmails to read with a space between:");
        StringBuffer Read=new StringBuffer();
        int curr;
        do {
          curr=System.in.read();
          Read.append((char)curr);
        } while(curr!='\n');

        //strip of the final \n
        Read.setLength(Read.length()-1);
     
        //if just Enter, we read remaining mails
        if(Read.length()==0) {
          for(int l=already; l<nbMails; l++) readMail(l+1);
        }
        else {
          //if 0, we read everything
          if(Read.equals("0")) {
            for(int i=0; i<nbMails; i++) readMail(i+1);
          }
          //or we read just the typed ones
          else {
            StringTokenizer st=new StringTokenizer(Read.toString());
            while(st.hasMoreTokens()) {
              try {
                readMail(Integer.parseInt(st.nextToken()));
              }
              catch(Exception eee) {System.out.println("Incorrect number"); System.exit(-1);}
            }
          }
        }
      }//if wait
      else {
        //read remaining by default
        for(int l=already; l<nbMails; l++) readMail(l+1);
      }

      //we write the number of mails already read
      if(nbMails!=already) putRead(nbMails);
      //we close everything
      out.writeBytes("QUIT\r\n");
      System.out.println("Connection closed");
      System.out.println("(C) 1997, 1998, 1999, 2000 Vasile Calmatui, vasile@wook.com");
      sock.close();
      //wait user types something and exit the program
      if(wait) System.in.read();
    }
    catch(IOException e) {System.out.println("Connection problem or connection closed");}
  };//end of constructor

  //reads the ini_file and configure the program
  void readIniFile() {
    try {
      RandomAccessFile file=new RandomAccessFile(iniFile, "r");
      try {
        String line=file.readLine();
        while(line!=null) {
          //if it's under windows (CR/LF)
          if(line.endsWith("\r")) line=new String(line.substring(0, line.length()-1));
          //reading each line and storing in keyValue
          for(int i=0; i<keywords.length; i++) {
            if(line.toLowerCase().startsWith(keywords[i])) keyValue[i]=new String(line.substring(keywords[i].length()+1));
          }
          line=file.readLine();
        }
      }
      catch (IOException ie) {System.out.println("Ini file problem");}
    }
    catch(IOException exc) {System.out.println("Opening ini file problem"); System.exit(-1);}
  }//end readIniFile

  //reads the nmb_file and configure the program
  int readNmbFile() {
    try {
      File newFile=new File(nmbFile);
      //does the file already exists
      if(newFile.exists()) {
        int toReturn=0;
        RandomAccessFile file=new RandomAccessFile(nmbFile, "r");
        String line=file.readLine();
        if(line!=null) {
          //if it's under windows (CR/LF)
          if(line.endsWith("\r")) line=new String(line.substring(0, line.length()-1));
          try {
            toReturn=Integer.parseInt(line);
          }
          catch(Exception eee) {System.out.println("Bad already_read parameter!!");}
        }//if
        file.close();
        return toReturn;
      }//if
    }//end try
    catch(IOException exc) {System.out.println("Problem reading nmbFile");}
    System.out.println("Defaulting to 0 mails read.");
    return 0;
  }//end readNmbFile

  //writes the number of read mails
  void putRead(int nb) {
    try {
      //does the file already exists
      {
        File newOne=new File(nmbFile);
        if(newOne.exists()) {
          newOne.delete();
        }//end if
      }//end exists
      //writing the actual number of messages read
      RandomAccessFile file=new RandomAccessFile(nmbFile, "rw");
      file.writeBytes(""+nb);
      file.close();
    }//end try
    catch(IOException exc) {System.out.println("Problem writing nmbFile");}
  }//end putRead

  //to read one mail function
  void readMail(int num_mess) {
    if(num_mess<1 || num_mess>nbMails) {
      System.out.println("Number "+num_mess+" incorrect!");
      return;
    }
    StringBuffer mail=new StringBuffer();
    try {
      System.out.println("Reading "+num_mess);
      out.writeBytes("retr "+num_mess+"\r\n");

      //+OK 963 octets
      String line=in.readLine();
      //first line of the message
      line=in.readLine();
      //and the other ones
      while(!line.equals(".")) {
        mail.append(line+ls);
        line=in.readLine();
      }
      System.out.println("Mail "+num_mess+" received");
      //function to write the mail in the file
      try {
        RandomAccessFile file=new RandomAccessFile(keyValue[4], "rw");
        file.seek(file.length());
        file.writeBytes(num_mess+"*************************************"+ls);
        file.writeBytes(num_mess+"*************************************"+ls);
        file.writeBytes(num_mess+"*************************************"+ls);
        file.writeBytes(mail.toString());
        file.close();
      }
      catch(IOException ef) {System.out.println("Problem writing mail file"); System.exit(3);}
      //end function
    }
    catch(IOException exc) {System.out.println("Problem reading mail"); System.exit(3);}
  }//end readMail
}//end of the class
